/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: discard.h,v 1.5 2009/12/24 05:44:56 abe Exp abe $
 */

#ifndef _DISCARD_H_
#define _DISCARD_H_

/* 
 *  DISCARD С饤ȤΥå
 */

#define TCP_DISCARD_SRV_STACK_SIZE	1024		/* TCP DISCARD ХΥå */
#define TCP_DISCARD_CLI_STACK_SIZE	1024		/* TCP DISCARD 饤ȥΥå */
#define UDP_DISCARD_CLI_STACK_SIZE	1024		/* UDP DISCARD 饤ȥΥå */

/* 
 *  DISCARD С饤Ȥͥ
 */

#define TCP_DISCARD_SRV_MAIN_PRIORITY	5	/* TCP DISCARD Хͥ */
#define TCP_DISCARD_CLI_MAIN_PRIORITY	5	/* TCP DISCARD 饤ȥͥ */
#define UDP_DISCARD_CLI_MAIN_PRIORITY	5	/* UDP DISCARD 饤ȥͥ */

/*
 *  TCP ɥХåե
 */

#if defined(NUM_MPF_NET_BUF_IF_PDU) && NUM_MPF_NET_BUF_IF_PDU > 0

#define TCP_DISCARD_CLI_SWBUF_SIZE	((IF_MTU-(IP_HDR_SIZE+TCP_HDR_SIZE))*1)
#define TCP_DISCARD_SRV_RWBUF_SIZE	((IF_MTU-(IP_HDR_SIZE+TCP_HDR_SIZE))*1)

#else	/* of #if defined(NUM_MPF_NET_BUF_IF_PDU) && NUM_MPF_NET_BUF_IF_PDU > 0 */

#if defined(SUPPORT_INET4)

#define TCP_DISCARD_CLI_SWBUF_SIZE	(TCP_MSS)
#define TCP_DISCARD_SRV_RWBUF_SIZE	(TCP_MSS)

#endif	/* of #if defined(SUPPORT_INET4) */

#if defined(SUPPORT_INET6)

#define TCP_DISCARD_CLI_SWBUF_SIZE	(TCP6_MSS)
#define TCP_DISCARD_SRV_RWBUF_SIZE	(TCP6_MSS)

#endif	/* of #if defined(SUPPORT_INET6) */

#endif	/* of #if defined(NUM_MPF_NET_BUF_IF_PDU) && NUM_MPF_NET_BUF_IF_PDU > 0 */

/*
 *  ѿ
 */

extern bool_t	tcp_discard_cli_valid;
extern bool_t	udp_discard_cli_valid;

/* TCP Хåե */

extern uint8_t tcp_discard_cli_swbuf[];
extern uint8_t tcp_discard_cli_rwbuf[];

extern uint8_t tcp_discard_srv_swbuf[];
extern uint8_t tcp_discard_srv_rwbuf[];

/*
 *  
 */

extern void tcp_discard_srv_task(intptr_t exinf);
extern void tcp_discard_cli_task(intptr_t exinf);

extern void udp_discard_cli_task(intptr_t exinf);

/*
 *  ؿ
 */

extern ER callback_nblk_tcp_discard_cli (ID cepid, FN fncd, void *p_parblk);

#endif	/* of #ifndef _DISCARD_H_ */
